

# BatchUpdateDetector


**Important**  
End of support notice: On May 20,2026, AWS will end support for AWS IoT Events. After May 20,2026, you will no longer be able to access the AWS IoT Events console or AWS IoT Events resources. For more information, see [AWS IoT Events end of support](https://docs.aws.amazon.com/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Updates the state, variable values, and timer settings of one or more detectors (instances) of a specified detector model.

## Request Syntax


```
POST /detectors HTTP/1.1
Content-type: application/json

{
   "detectors": [ 
      { 
         "detectorModelName": "string",
         "keyValue": "string",
         "messageId": "string",
         "state": { 
            "stateName": "string",
            "timers": [ 
               { 
                  "name": "string",
                  "seconds": number
               }
            ],
            "variables": [ 
               { 
                  "name": "string",
                  "value": "string"
               }
            ]
         }
      }
   ]
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [detectors](#API_iotevents-data_BatchUpdateDetector_RequestSyntax) **   <a name="iotevents-iotevents-data_BatchUpdateDetector-request-detectors"></a>
The list of detectors (instances) to update, along with the values to update.  
Type: Array of [UpdateDetectorRequest](API_iotevents-data_UpdateDetectorRequest.md) objects  
Array Members: Minimum number of 1 item.  
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "batchUpdateDetectorErrorEntries": [ 
      { 
         "errorCode": "string",
         "errorMessage": "string",
         "messageId": "string"
      }
   ]
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [batchUpdateDetectorErrorEntries](#API_iotevents-data_BatchUpdateDetector_ResponseSyntax) **   <a name="iotevents-iotevents-data_BatchUpdateDetector-response-batchUpdateDetectorErrorEntries"></a>
A list of those detector updates that resulted in errors. (If an error is listed here, the specific update did not occur.)  
Type: Array of [BatchUpdateDetectorErrorEntry](API_iotevents-data_BatchUpdateDetectorErrorEntry.md) objects

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iotevents-data-2018-10-23/BatchUpdateDetector) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iotevents-data-2018-10-23/BatchUpdateDetector) 